///home/berryj/link/bin/genMethods "-g" "-t" "int" "-h" "SortedArray" "-r" "Array<int>" "-I" "LINK/basic/SortedArray.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SortedArray.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ArrayWrapper.h>


typedef int _int;
typedef SortedArray<int > _SortedArray_int_;
static SortedArray<int > s__SortedArray_int_;

#define _SortedArray_int_DATA(x) ((SortedArray<int >*) (EXTDATA(x)))
#define _SortedArray_int_IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedArray<int > >::type))
#define _SortedArray_int_ISNT_DATA(x) (!_SortedArray_int_IS_DATA(x))

#define _SortedArray_int_CXX_DATA(x) (*(SortedArray<int >*) (EXTDATA(VAL(x))))
#define _SortedArray_int_CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedArray<int > >::type))
#define _SortedArray_int_CXX_ISNT_DATA(x) (!_SortedArray_int_CXX_IS_DATA(x))


PRIMITIVE STk_init__SortedArray_int_()
{
	Wrapper<_SortedArray_int_>::type = STk_new_CXXwrapper_id(
			Wrapper<_SortedArray_int_>::name, 
			Wrapper<Array<int> >::name,
			(void (*)(SCM x, SCM port, int mode))
			ArrayWrapper<_int>::displayTypedArray,
			(void (*)(SCM x))ArrayWrapper<_int>::markTypedArray,
			(void (*)(SCM x))ArrayWrapper<_int>::freeTypedArray);
	Tcl_InitHashTable(&Register<_SortedArray_int_>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_SortedArray_int_Methods(void);

PRIMITIVE STk_init_methods__SortedArray_int_()
{
	genExtra_SortedArray_int_Methods();
	return UNDEFINED;
}
